#!/bin/sh
# This script should build pspp, first downloading required dependances

export BUILD_DIR=`pwd`
W32_NSI=$BUILD_DIR/../nsi
DOWNLOAD_DIR=$BUILD_DIR/downld
HOST_TOOLS_PREFIX=$BUILD_DIR/host_tools
mkdir $HOST_TOOLS_PREFIX
DOWNLOAD=mydownload.sh

OLD_ACLOCAL_DIR=`aclocal --print-ac-dir`

#export PATH=$BUILD_DIR/automake-1.10.prefix/bin:$BUILD_DIR/gettext-0.16.1.prefix/bin:$BUILD_DIR/autoconf-2.61.prefix/bin:$PATH
export PATH=$HOST_TOOLS_PREFIX/bin:$PATH

(cd $BUILD_DIR/automake-1.10.prefix/share
 if [ ! -e aclocal ]
  then ln -s aclocal-1.10 aclocal
 fi
) 



#echo ENTER && read




#autoconf --version
#read

AUTOCONF_VERSION_MINOR=`autoconf --version 2>&1 | head -n1 | sed 's/.*\.//g'`
AUTOCONF_VERSION_MINOR_REQ=60
#if [ `autoconf --version 2>&1 | head -n1 | sed 's/.*\.//g'` -lt 59 ] ; then NEED_NEW_AUTOCONF=yes echo old ;fi


#cat  $CPREFIX/tmp.$d.finished || (  (cd $d && ../cross-configure.sh --prefix=$CPREFIX && ../cross-make.sh && ../cross-make.sh install  && echo Complete > $CPREFIX/tmp.$d.finished ) 2>&1 | tee $d.log  )
d=automake-1.10
which $d  || (. ~/bin/distcc.env && export CC="gcc" ; export CXX="g++" ; . ~/bin/distcc.env  echo pwd `pwd` ; cd $d && (ls Makefile || ./configure --prefix=$HOST_TOOLS_PREFIX --disable-java ) && ( nice make -j24 || make ) && nice make install)
automake --version/


#read

if [ ! -f ./cross.env ]
then
  echo Could not find cross.env in the current working directory: `pwd` 
  exit
fi

#ftp://ftp.gtk.org/pub/gtk/v2.10/gtk+-2.10.11.tar.bz2

	#http://www.winterdrache.de/freeware/png2ico/data/png2ico-win-2002-12-08.zip
	#http://www.winterdrache.de/freeware/png2ico/data/png2ico-src-2002-12-08.tar.gz
	#http://canzoniere.ilbello.com/php-gtk/glade3-3.1.2-win32-1.zip 
#mPWD=`pwd`
#http://www.libsdl.org/extras/win32/cross/mingw32-linux-x86-glibc-2.3.tar.gz 
URLS="
	http://icon-theme.freedesktop.org/releases/hicolor-icon-theme-0.10.tar.gz
	http://www.ucc.asn.au/~mccabedj/pspp/GTK2.10.tar.gz
        http://www.ucc.asn.au/~mccabedj/pspp/NSIS.lite.tar.bz2
	http://prdownloads.sf.net/mingw/w32api-3.6.tar.gz?download 
	http://downloads.sourceforge.net/gnuwin32/plotutils-2.4.1-4-bin.zip 
	http://downloads.sourceforge.net/gnuwin32/plotutils-2.4.1-4-lib.zip 
 	ftp://ftp.gnu.org/gnu/gsl/gsl-1.8.tar.gz"

which autopoint || URLS="$URLS ftp://gnu.mirror.pacific.net.au/gnu/gnu/gettext/gettext-0.16.1.tar.gz"

( if ls `aclocal --print-ac-dir` | grep libtool
then
  echo libtool found
else 
	#cd `aclocal --print-ac-dir` && for f in `ls "$OLD_ACLOCAL_DIR"`
	#	do echo "$f" && ln -s "$OLD_ACLOCAL_DIR/$f" .
	#done
	URLS="$URLS http://ftp.gnu.org/gnu/libtool/libtool-1.5.22.tar.gz"
fi )
echo $AUTOCONF_VERSION_MINOR $AUTOCONF_VERSION_MINOR_REQ
if [ $AUTOCONF_VERSION_MINOR -lt $AUTOCONF_VERSION_MINOR_REQ ] 
then
	URLS="$URLS http://ftp.gnu.org/gnu/libtool/libtool-1.5.22.tar.gz ftp://gnu.mirror.pacific.net.au/gnu/gnu/autoconf/autoconf-2.61.tar.bz2"
	#URLS="$URLS http://ftp.gnu.org/gnu/libtool/libtool-1.5.22.tar.gz ftp://gnu.mirror.pacific.net.au/gnu/gnu/autoconf/autoconf-2.61.tar.bz2"
        echo $URLS
fi

#echo PRESS ENTER && read

for u in $URLS
do
 echo URL: $u
 f=`echo "$u" | sed 's/.*\///' | sed 's/\?download$//'`
 if [ \( ! -f "$f" \) -a  \( ! -f "downld/$f" \) ]
 then 
 echo $u '->' \"$f\"
  if [ ! -e $f ]
  then 
    echo DOWNLOAD: $u
    #mydownload.sh "$u"
    $DOWNLOAD "$u"
    
    if [ ! -e downld ]
    then
       ln -s . downld
    fi
    mv $f downld/
  fi
 fi 
done

if [ $AUTOCONF_VERSION_MINOR -lt $AUTOCONF_VERSION_MINOR_REQ ] 
then
	echo autoconf too old, building new version && read
	
	d=autoconf-2.61
	if [ ! -e $d ] 
	then
		tar -jxf $DOWNLOAD_DIR/$d.tar.bz2
	fi
	#. ~/bin/distcc.env && export CC="distcc gcc" && export CXX="distcc g++" ; mkdir $d.prefix ; echo pwd `pwd` ; cd $d && ./configure --prefix=$BUILD_DIR/$d.prefix && nice make -j1 && nice make install
(	. ~/bin/distcc.env && export CC="distcc gcc" && export CXX="distcc g++" ; echo pwd `pwd` ; cd $d && (ls Makefile || ./configure --prefix=$HOST_TOOLS_PREFIX) && nice make -j24 && nice make install )
fi

#echo PRESS ENTER .2. && read
echo NSIS
d=NSIS.lite
ls -ld $d || tar -jxvf  $DOWNLOAD_DIR/$d.tar.bz2

echo GETTEXT
d=gettext-0.16.1
which autopoint || ls $d > /dev/null || tar -zxf downld/$d.tar.gz
which autopoint || ( echo autopoint not found, press enter to build autopoint/gettext && read &&
 . ~/bin/distcc.env && export CC="distcc gcc" && export CXX="distcc g++"  echo pwd `pwd` ; cd $d && (ls Makefile || ./configure --disable-java --prefix=$HOST_TOOLS_PREFIX) && nice make -j12 && nice make install)


#if ls `aclocal --print-ac-dir` | grep libtool
if true
then
	echo #libtool found
else
ls `aclocal --print-ac-dir`
echo aclocal --print-ac-dir
     echo libtool not found, press enter to build new version && read
     $d=libtool-1.5.22
     if [ ! -e libtool-1.5.22 ] 
	then tar -zxf "$DOWNLOAD_DIR/libtool-1.5.22.tar.gz"
     fi
( . ~/bin/distcc.env && (true || export CC="distcc gcc" && export CXX="distcc g++") ; echo pwd `pwd` ; cd $d && (ls Makefile || ./configure --disable-java --prefix=$HOST_TOOLS_PREFIX) && nice make -j24 && nice make install) 2>&1 | tee libtool.log || ( echo LIBTOOL build failed ; exit )
     #exit
fi


. ./cross.env # FROM NOW ON, ONLY BUILD CROSS COMPILED EXECUTABLES


#echo HII && read 
#http://downloads.sourceforge.net/gladewin32/gtk-dev-2.10.7-win32-1.exe 

if [ ! -d $CPREFIX ] 
then 

echo $CPREFIX does not exist
echo unpacking
sleep 1 

 (
#tar -zxvf $DOWNLOAD_DIR/w32api-3.1.tar.gz &&
cd $UNPACKROOT
tar -zxvf $DOWNLOAD_DIR/mingw32-linux-x86-glibc-2.3.tar.gz
#mkdir cross-tools
#cd $UNPACKDIR &&
#cp -rv /home/elizabeth/.wine/drive_c/GTK2.10/* . &&
cd $CPREFIX &&
ln -s $CPREFIX/include/{.,win32} &&
tar -zxvf $DOWNLOAD_DIR/w32api-3.6.tar.gz &&
#tar -zxvf $DOWNLOAD_DIR/GTK2.6.10-rc1.tar.gz
tar -zxvf $DOWNLOAD_DIR/GTK2.10.tar.gz  
#tar -zxvf $DOWNLOAD_DIR/gtk-dev-2.6.10-rev-a.tar.gz &&

#cp -r gtk_2_0/* . 
) # end unpacking

echo unzipping

# true ||
 (
cd $CPREFIX || ( echo cannot enter  $CPREFIX && read stop )
#unzip $DOWNLOAD_DIR/glade-*.zip
#unzip $DOWNLOAD_DIR/glade-3-0-2-win32-1.zip
#unzip $DOWNLOAD_DIR/readline-5.0-lib.zip
#unzip $DOWNLOAD_DIR/plotutils-2.4.1-4-bin.zip
unzip $DOWNLOAD_DIR/plotutils-2.4.1-4-bin.zip
#unzip $DOWNLOAD_DIR/plotutils-2.4.1-4-dep.zip
unzip $DOWNLOAD_DIR/plotutils-2.4.1-4-lib.zip
#unzip $DOWNLOAD_DIR/glade3-3.1.2-win32-1.zip #Change prefix?
ln $CPREFIX/bin/{libfontconfig-1,fontconfig}.dll

)


# true ||
 (cd $CPREFIX/lib/pkgconfig/
ls
for f in *.pc ; do
   #if grep 'prefix=/target' $f >/dev/null 2>&1 ; then
   if grep 'prefix=/target' $f  ; then
     #cat $f | sed s+^prefix=/target+prefix=$TARGET+ | tee $f.tmp
     cat $f | sed s+^prefix=/target+prefix=$CPREFIX+ | tee $f.tmp
     mv $f.tmp $f
   elif grep 'prefix=c:/devel/target/' $f >/dev/null 2>&1 ; then
       cat $f | sed s+^prefix=c:/devel/target+prefix=$CPREFIX+ | tee $f.tmp
	mv $f.tmp $f
   elif grep 'prefix=/devel/target/' $f >/dev/null 2>&1 ; then
       cat $f | sed s+^prefix=/devel/target+prefix=$CPREFIX+ | tee $f.tmp
       mv $f.tmp $f
   #elif grep 'prefix=/home/glade3' $f >/dev/null 2>&1 ; then
   #    #cat $f | sed s+^prefix=/home/glade3+prefix=$CPREFIX+ | tee $f.tmp
   #    cat $f | sed s+^prefix=/home/glade3+prefix=$CPREFIX/glade3+ | tee $f.tmp
   #    mv $f.tmp $f
   fi 
done 
)  

 (cd $CPREFIX/glade3/lib/pkgconfig/
for f in *.pc ; do
   if grep 'prefix=/home/glade3' $f >/dev/null 2>&1 ; then
       #cat $f | sed s+^prefix=/home/glade3+prefix=$CPREFIX+ | tee $f.tmp
       cat $f | sed s+^prefix=/home/glade3+prefix=$CPREFIX/glade3+ | tee $f.tmp
       mv $f.tmp $f
   fi 
done
)

fi # if [ -d $CPREFIX ] 
#echo WAIT && read stop

echo
echo $CPREFIX/lib/pkgconfig/
echo $CPREFIX/lib/pkgconfig/
echo 

#sleep 9

d=hicolor-icon-theme-0.10
(ls -ld $d || tar -zxf $DOWNLOAD_DIR/$d.tar.gz)
cat  $CPREFIX/tmp.$d.finished || ( echo building $d && (cd $d && ../cross-configure.sh --prefix=$CPREFIX  && ../cross-make.sh && ../cross-make.sh install && echo Complete > $CPREFIX/tmp.$d.finished ) 2>&1 | tee $d.log )

echo TMP && read

d=hicolor-icon-theme-0.10
#(cd $d &&  cross-make.sh ) 2>&1 | tee $d.log 
d=glade3-3.1.4
#(cd $d && PKG_CONFIG_PATH=$CPREFIX/lib/pkgconfig/:$CPREFIX/lib/pkgconfig/ cross-configure.sh --prefix=$CPREFIX --with-gui-tools && cross-make.sh && cross-make.sh install) 2>&1 | tee $d.log 
#exit
d=plotutils-2.5 
#(cd $d && cross-configure.sh --prefix=$CPREFIX && cd libplot && cross-make.sh && cross-make.sh install) 2>&1 | tee $d.log 
d=gsl-1.8
cat  $CPREFIX/tmp.$d.finished || ( echo BUILDING GSL ; sleep 2;  (   (cd $d && ../cross-configure.sh --prefix=$CPREFIX && ../cross-make.sh && ../cross-make.sh install  && echo Complete > $CPREFIX/tmp.$d.finished )  || ( echo GSL build failed && sleep 10 )  ) 2>&1 | tee $d.log  )
#d=ncurses-*
#d=termcap-1.3.1
#(cd $d && cross-configure.sh --prefix=$CPREFIX && cross-make.sh && cross-make.sh install) 2>&1 | tee $d.log
#d=readline-5.2
#(cd $d && cross-configure.sh --prefix=$CPREFIX && cross-make.sh && cross-make.sh install) 2>&1 | tee $d.log
#(cd $d/src/readline/5.0/readline-5.0-src/ && cross-configure.sh --prefix=$CPREFIX && cross-make.sh && cross-make.sh install) 2>&1 | tee $d.log
d=pspp 
#(cd $d && PKG_CONFIG_PATH=$CPREFIX/glade3/lib/pkgconfig/:$CPREFIX/glade3/lib/pkgconfig/:$CPREFIX/lib/pkgconfig/:$CPREFIX/lib/pkgconfig/ cross-configure.sh --prefix=$CPREFIX --with-gui-tools && cross-make.sh cp $CPREFIX/include/string.h gl/string.h && cross-make.sh install) 2>&1 | tee $d.log 
#d=screen-4.0.2
#(cd $d && cross-configure.sh --prefix=$CPREFIX && cross-make.sh && cross-make.sh install) 2>&1 | tee $d.log
#$CPREFIX/bin/mingwm10.dll:$CPREFIX/lib/pango/1.5.0/modules/pango-indic-lang.dll:$CPREFIX/lib/gtk-2.0/2.4.0/engines/libmetal.dll:$CPREFIX/lib/gtk-2.0/2.10.0/engines/libwimp.dll:$CPREFIX/glade3/bin/libgladeui-1-4.dll:$CPREFIX/glade3/lib/glade3/modules/libgladegtk.dll
( cd pspp
  cd ..
  if [ ! -e gnulib ]
    then cvs -z3 -d:pserver:anonymous@cvs.savannah.gnu.org:/sources/gnulib co gnulib
  fi
)

( cd ../../..
  #if [ ! -e gnulib ]
  rm gnulib
  ln -s `pwd`/pspp/w32/build/gnulib gnulib
)

d=acversions.log
ls -l $d || (
 echo 
 echo "XXX   autoconf --version   XXX"
 autoconf --version 
 echo 
 echo "XXX   automake --version   XXX"
 automake --version
 echo 
 echo "XXX   autopoint --version   XXX"
 autopoint --version
 echo 
 echo "XXX   ls \`aclocal --print-ac-dir\`  XXX"
 ls `aclocal --print-ac-dir`
 echo 
 echo "XXX   aclocal --print-ac-dir  XXX"
 aclocal --print-ac-dir
 echo 
 echo "XXX   aclocal --version  XXX"
 aclocal --version
 echo 
 #echo "XXX   aclocal --verbose  XXX"
 #( cd pspp && aclocal --verbose  ) || ( echo aclocal --verbose failed && exit )
 echo 
 echo "XXX   CC  --version  XXX"
 $CC --version
) 2>&1 | tee $d 

#cd pspp && make -f Smake

#echo Link old m4 files into current aclocal_dir && read


#(	cd `aclocal --print-ac-dir` && for f in `ls "$OLD_ACLOCAL_DIR"`
		#do echo "$f" && ln -s "$OLD_ACLOCAL_DIR/$f" .
	#done )
#
#echo SECOND PART && sleep 2
#
#(	cd $HOST_TOOLS_PREFIX/share/aclocal-1.10 && for f in `ls $HOST_TOOLS_PREFIX/share/aclocal/`
		#do echo "$f" && ln -s "$HOST_TOOLS_PREFIX/share/aclocal/$f" .
	#done )
#read

d=pspp 
(cd $d && 
  (ls -l configure || make -f Smake) &&
  ( ls -l Makefile || $BUILD_DIR/cross-configure.sh --prefix=$CPREFIX --enable-relocatable) &&
  ( grep dlltool < Makefile || $BUILD_DIR/pspp.postconfigure.sh #PATCH IS BROKEN
) &&
  ( ls -l w32/res/psppire-res.o || sh w32/res/makeres.sh ) &&
  # $BUILD_DIR/cross-make.sh &&
  ( $BUILD_DIR/cross-make.sh && $BUILD_DIR/cross-make.sh install && true || $BUILD_DIR/make.check.sh ) || ( echo PSPP build failed && exit )  ) 2>&1 | tee pspp.log

sleep 3

(cd $CPREFIX &&
   (rm PSPPIRE-*-Setup.exe ; 
   cp $W32_NSI/*.nsi . &&
   cp $W32_NSI/README.txt . &&
   cp $BUILD_DIR/pspp/COPYING . &&
   wine $BUILD_DIR/NSIS.lite/makensis.exe psppire.nsi &&
#f=`ls PSPPIRE-*-Setup.exe`
for f in `ls PSPPIRE-*-Setup.exe`
do
   myupload.sh $f pspp/$f
done
))


#(cd $d && ../cross-configure.sh --prefix=$CPREFIX --without-gui && ../pspp.postconfigure.sh && ../cross-make.sh && ../make.check.sh  )

#(cd $d && #cross-configure.sh --prefix=$CPREFIX --with-gui-tools && 
#( PKG_CONFIG_PATH=$CPREFIX/lib/pkgconfig/  LD_LIBRARY_PATH=$LD_LIBRARY_PATH:$CPREFIX/bin/mingwm10.dll:$CPREFIX/lib/pango/1.5.0/modules/pango-indic-lang.dll:$CPREFIX/lib/gtk-2.0/2.4.0/engines/libmetal.dll:$CPREFIX/lib/gtk-2.0/2.10.0/engines/libwimp.dll:$CPREFIX/glade3/bin/libgladeui-1-4.dll:$CPREFIX/glade3/lib/glade3/modules/libgladegtk.dll:$CPREFIX/lib:$CPREFIX/glade3/lib:$CPREFIX/glade3/lib/glade3/modules/:$CPREFIX/bin/mingwm10.dll: cross-make.sh || (  
#cp $CPREFIX/include/string.h gl/string.h &&
#PKG_CONFIG_PATH=$CPREFIX/lib/pkgconfig/ LD_LIBRARY_PATH=$LD_LIBRARY_PATH:$CPREFIX/bin/mingwm10.dll:$CPREFIX/lib/pango/1.5.0/modules/pango-indic-lang.dll:$CPREFIX/lib/gtk-2.0/2.4.0/engines/libmetal.dll:$CPREFIX/lib/gtk-2.0/2.10.0/engines/libwimp.dll:$CPREFIX/glade3/bin/libgladeui-1-4.dll:$CPREFIX/glade3/lib/glade3/modules/libgladegtk.dll:$CPREFIX/lib:$CPREFIX/glade3/lib:$CPREFIX/glade3/lib/glade3/modules/:$CPREFIX/bin/mingwm10.dll: cross-make.sh) && cross-make.sh install ) )
#
