#!/bin/sh
# This converts a list of files to an script suitable for including from an
# .nsi script.

old_path='**NO_PATH_SET**'
do_not_modify="#Automatically generated by $0.  Do Not Modify."

echo $do_not_modify > $1.inst.nsi 
echo $do_not_modify > $1.del.nsi 
echo $do_not_modify > $1.rmdir_unsorted.nsi 

if [ -z "$1" ] 
then
	echo Usage: $0 FILES
	echo Creates FILES.inst.nsi FILES.del.nsi FILES.rmdir.nsi
	exit
fi

#rm $1.inst.nsi
#rm $1.del.nsi
#rm $1.rmdir.nsi
#rm $1.rmdir_unsorted.nsi

cat $1.list | sed 's/\//\\/g' | while read -r f
do
	#echo
	echo -E "$f" 
	if echo -E "$f" | grep '\\' > /dev/null
	then
		true
		#path=`echo -E $f | sed 's/\\[^\\]*$//'`
		path=`echo -E $f | sed 's/[\\][^\\]*$//'`
		file=`echo -E $f | sed 's/.*[\\]//'`
	else
		path=""
		file="$f"
	fi

	#echo "PATH: $path"
	#echo "FILE: $file"
	if [ "$old_path" != "$path" ]
	then
		echo >> $1.inst.nsi
		echo -E 'SetOutPath "$INSTDIR\'"$path"'"' >> $1.inst.nsi
		old_path="$path"

		rmpath=$f
		
		while echo -E "$rmpath" | grep '\\' > /dev/null
		do
			rmpath=`echo -E $rmpath | sed 's/[\\][^\\]*$//'`
			echo -E 'RMDir "$INSTDIR\'"$rmpath"'"' >> $1.rmdir_unsorted.nsi
			echo "RMPATH: $rmpath"
		done


	fi

	echo -E 'File "'$f'"' >> $1.inst.nsi
	echo -E 'Delete "$INSTDIR\'"$f"'"' >> $1.del.nsi

done

(echo $do_not_modify && sort -r -u < $1.rmdir_unsorted.nsi ) > $1.rmdir.nsi
